/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the IdentityMembershipRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &IdentityMembershipRequest{}

// IdentityMembershipRequest struct for IdentityMembershipRequest
type IdentityMembershipRequest struct {
	GroupId    NullableString `json:"groupId,omitempty"`
	IdentityId NullableString `json:"identityId,omitempty"`
	Comment    NullableString `json:"comment,omitempty"`
	Email      NullableString `json:"email,omitempty"`
}

// NewIdentityMembershipRequest instantiates a new IdentityMembershipRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewIdentityMembershipRequest() *IdentityMembershipRequest {
	this := IdentityMembershipRequest{}
	return &this
}

// NewIdentityMembershipRequestWithDefaults instantiates a new IdentityMembershipRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewIdentityMembershipRequestWithDefaults() *IdentityMembershipRequest {
	this := IdentityMembershipRequest{}
	return &this
}

// GetGroupId returns the GroupId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentityMembershipRequest) GetGroupId() string {
	if o == nil || IsNil(o.GroupId.Get()) {
		var ret string
		return ret
	}
	return *o.GroupId.Get()
}

// GetGroupIdOk returns a tuple with the GroupId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentityMembershipRequest) GetGroupIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.GroupId.Get(), o.GroupId.IsSet()
}

// HasGroupId returns a boolean if a field has been set.
func (o *IdentityMembershipRequest) HasGroupId() bool {
	if o != nil && o.GroupId.IsSet() {
		return true
	}

	return false
}

// SetGroupId gets a reference to the given NullableString and assigns it to the GroupId field.
func (o *IdentityMembershipRequest) SetGroupId(v string) {
	o.GroupId.Set(&v)
}

// SetGroupIdNil sets the value for GroupId to be an explicit nil
func (o *IdentityMembershipRequest) SetGroupIdNil() {
	o.GroupId.Set(nil)
}

// UnsetGroupId ensures that no value is present for GroupId, not even an explicit nil
func (o *IdentityMembershipRequest) UnsetGroupId() {
	o.GroupId.Unset()
}

// GetIdentityId returns the IdentityId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentityMembershipRequest) GetIdentityId() string {
	if o == nil || IsNil(o.IdentityId.Get()) {
		var ret string
		return ret
	}
	return *o.IdentityId.Get()
}

// GetIdentityIdOk returns a tuple with the IdentityId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentityMembershipRequest) GetIdentityIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.IdentityId.Get(), o.IdentityId.IsSet()
}

// HasIdentityId returns a boolean if a field has been set.
func (o *IdentityMembershipRequest) HasIdentityId() bool {
	if o != nil && o.IdentityId.IsSet() {
		return true
	}

	return false
}

// SetIdentityId gets a reference to the given NullableString and assigns it to the IdentityId field.
func (o *IdentityMembershipRequest) SetIdentityId(v string) {
	o.IdentityId.Set(&v)
}

// SetIdentityIdNil sets the value for IdentityId to be an explicit nil
func (o *IdentityMembershipRequest) SetIdentityIdNil() {
	o.IdentityId.Set(nil)
}

// UnsetIdentityId ensures that no value is present for IdentityId, not even an explicit nil
func (o *IdentityMembershipRequest) UnsetIdentityId() {
	o.IdentityId.Unset()
}

// GetComment returns the Comment field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentityMembershipRequest) GetComment() string {
	if o == nil || IsNil(o.Comment.Get()) {
		var ret string
		return ret
	}
	return *o.Comment.Get()
}

// GetCommentOk returns a tuple with the Comment field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentityMembershipRequest) GetCommentOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Comment.Get(), o.Comment.IsSet()
}

// HasComment returns a boolean if a field has been set.
func (o *IdentityMembershipRequest) HasComment() bool {
	if o != nil && o.Comment.IsSet() {
		return true
	}

	return false
}

// SetComment gets a reference to the given NullableString and assigns it to the Comment field.
func (o *IdentityMembershipRequest) SetComment(v string) {
	o.Comment.Set(&v)
}

// SetCommentNil sets the value for Comment to be an explicit nil
func (o *IdentityMembershipRequest) SetCommentNil() {
	o.Comment.Set(nil)
}

// UnsetComment ensures that no value is present for Comment, not even an explicit nil
func (o *IdentityMembershipRequest) UnsetComment() {
	o.Comment.Unset()
}

// GetEmail returns the Email field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentityMembershipRequest) GetEmail() string {
	if o == nil || IsNil(o.Email.Get()) {
		var ret string
		return ret
	}
	return *o.Email.Get()
}

// GetEmailOk returns a tuple with the Email field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentityMembershipRequest) GetEmailOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Email.Get(), o.Email.IsSet()
}

// HasEmail returns a boolean if a field has been set.
func (o *IdentityMembershipRequest) HasEmail() bool {
	if o != nil && o.Email.IsSet() {
		return true
	}

	return false
}

// SetEmail gets a reference to the given NullableString and assigns it to the Email field.
func (o *IdentityMembershipRequest) SetEmail(v string) {
	o.Email.Set(&v)
}

// SetEmailNil sets the value for Email to be an explicit nil
func (o *IdentityMembershipRequest) SetEmailNil() {
	o.Email.Set(nil)
}

// UnsetEmail ensures that no value is present for Email, not even an explicit nil
func (o *IdentityMembershipRequest) UnsetEmail() {
	o.Email.Unset()
}

func (o IdentityMembershipRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o IdentityMembershipRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.GroupId.IsSet() {
		toSerialize["groupId"] = o.GroupId.Get()
	}
	if o.IdentityId.IsSet() {
		toSerialize["identityId"] = o.IdentityId.Get()
	}
	if o.Comment.IsSet() {
		toSerialize["comment"] = o.Comment.Get()
	}
	if o.Email.IsSet() {
		toSerialize["email"] = o.Email.Get()
	}
	return toSerialize, nil
}

type NullableIdentityMembershipRequest struct {
	value *IdentityMembershipRequest
	isSet bool
}

func (v NullableIdentityMembershipRequest) Get() *IdentityMembershipRequest {
	return v.value
}

func (v *NullableIdentityMembershipRequest) Set(val *IdentityMembershipRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableIdentityMembershipRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableIdentityMembershipRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIdentityMembershipRequest(val *IdentityMembershipRequest) *NullableIdentityMembershipRequest {
	return &NullableIdentityMembershipRequest{value: val, isSet: true}
}

func (v NullableIdentityMembershipRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIdentityMembershipRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
